﻿Type=Class
Version=2.2
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private CCPt() As PointApi 
	Private cv As Canvas 	
	Dim CCircle(2) As Circle3P 
	Private msg As String 
	Private msgbox As Msgboxes 	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	CCircle(0).Initialize 
	CCircle(1).Initialize 
End Sub
Public Sub Draw_CircleCircleIntersection(c As Canvas, p() As PointApi)
	CCPt=p
	cv=c
	Dim bl As Int  
	Dim ln As Short 

	CCircle(0).Center.x = CCPt(0).x 
	CCircle(0).Center.y = CCPt(0).y
	CCircle(0).Radius = Functions.Distance(CCPt(0),CCPt(1))	
	CCircle(1).Center.x = CCPt(2).x 
	CCircle(1).Center.y = CCPt(2).y
	CCircle(1).Radius = Functions.Distance(CCPt(2),CCPt(3))	
	bl=FindCircleCircleIntersections
	cv.ClearRect(0,0,cv.Width,cv.Height)	
	cv.DrawCircle(CCircle(0).Center.x, CCircle(0).Center.y, CCircle(0).radius, fx.Colors.Red, False,1)
	cv.DrawCircle(CCircle(1).Center.x, CCircle(1).Center.y, CCircle(1).radius, fx.Colors.Red, False,1)
	For i =0 To 3
		DrawPoint(CCPt(i))
	Next
	Dim f As Font 
	If bl>0 Then
		f=fx.CreateFont("system", 14,False,False)		
		ln = 20: cv.DrawText("X Center Circle 1 = " & CCircle(0).Center.x , 10, ln, f, fx.Colors.DarkGray , "LEFT")
		ln = ln + 20: cv.DrawText("Y Center Circle 1 = " & CCircle(0).Center.Y , 10, ln, f, fx.Colors.DarkGray , "LEFT")	
		ln = ln + 20: cv.DrawText("Radius Circle 1 = " & CCircle(0).radius, 10, ln, f, fx.Colors.DarkGray , "LEFT")		
		ln = ln + 20: cv.DrawText("X Center Circle 2 = " & CCircle(1).Center.x , 10, ln, f, fx.Colors.DarkGray , "LEFT")
		ln = ln + 20: cv.DrawText("Y Center Circle 2 = " & CCircle(1).Center.Y , 10, ln, f, fx.Colors.DarkGray , "LEFT")	
		ln = ln + 20: cv.DrawText("Radius Circle 2 = " & CCircle(1).radius, 10, ln, f, fx.Colors.DarkGray , "LEFT")		
		ln = ln + 20: cv.DrawText("X Intersection Point 1 = " & CCircle(0).CenterChord(0).x , 10, ln, f, fx.Colors.DarkGray , "LEFT")
		ln = ln + 20: cv.DrawText("Y Intersection Point 1 = " & CCircle(0).CenterChord(0).y , 10, ln, f, fx.Colors.DarkGray , "LEFT")
		drawPointCircle(CCircle(0).CenterChord(0), fx.Colors.Blue)
		If bl = 2 Then
			drawPointCircle(CCircle(0).CenterChord(1), fx.Colors.Blue)
			ln = ln + 20: cv.DrawText("X Intersection Point 2 = " & CCircle(0).CenterChord(1).x , 10, ln, f, fx.Colors.DarkGray , "LEFT")
			ln = ln + 20: cv.DrawText("Y Intersection Point 2 = " & CCircle(0).CenterChord(1).y , 10, ln, f, fx.Colors.DarkGray , "LEFT")
		End If
	Else
		f=fx.CreateFont("system", 14,True,False)		
		ln =  20: cv.DrawText(msg, 10, ln, f, fx.Colors.red, "LEFT")
	End If
	cv.DrawText("To modify click and drag the points.", 10,cv.Height-2,f,fx.Colors.DarkGray, "LEFT")
	
End Sub
Private Sub FindCircleCircleIntersections() As Int
        ' Find the distance between the centers.
        Dim dx As Float = CCircle(0).center.X - CCircle(1).Center.X
        Dim dy As Float =  CCircle(0).center.Y - CCircle(1).Center.Y
        Dim dist As Double = Sqrt(dx * dx + dy * dy)

        ' See how many solutions there are.
        If (dist > CCircle(0).Radius + CCircle(1).Radius) Then
            ' No solutions, the circles are too far apart.  
	        CCircle(0).CenterChord(0).x = -1
	        CCircle(0).CenterChord(0).y = -1
			CCircle(0).CenterChord(1).x = -1
			CCircle(0).CenterChord(1).y = -1
			msg="No solutions, the circles are too far apart."
			Return 0
        Else If (dist < Abs(CCircle(0).Radius - CCircle(1).Radius)) Then
            ' No solutions, one circle contains the other.
	        CCircle(0).CenterChord(0).x = -1
	        CCircle(0).CenterChord(0).y = -1
			CCircle(0).CenterChord(1).x = -1
			CCircle(0).CenterChord(1).y = -1
			msg="No solutions, one circle contains the other."
            Return 0
        Else If ((dist = 0) AND (CCircle(0).Radius = CCircle(1).Radius)) Then
            ' No solutions, the circles coincide.
	        CCircle(0).CenterChord(0).x = -1
	        CCircle(0).CenterChord(0).y = -1
			CCircle(0).CenterChord(1).x = -1
			CCircle(0).CenterChord(1).y = -1
			msg="No solutions, the circles coincide."
            Return 0
        Else
            ' Find a and h.
            Dim a As Double = (CCircle(0).Radius * CCircle(0).Radius - CCircle(1).Radius * CCircle(1).Radius + dist * dist) / (2 * dist)
            Dim h As Double = Sqrt(CCircle(0).Radius * CCircle(0).Radius - a * a)

            ' Find P2.
            Dim cx2 As Double = CCircle(0).center.X + a * (CCircle(1).Center.X - CCircle(0).center.X) / dist
            Dim cy2 As Double =  CCircle(0).center.Y + a * (CCircle(1).Center.Y -  CCircle(0).center.Y) / dist

            ' Get the points P3
 			CCircle(0).CenterChord(0).x = cx2 + h * (CCircle(1).Center.Y -  CCircle(0).center.Y) / dist
	        CCircle(0).CenterChord(0).y = cy2 - h * (CCircle(1).Center.X - CCircle(0).center.X) / dist
			CCircle(0).CenterChord(1).x = cx2 - h * (CCircle(1).Center.Y -  CCircle(0).center.Y) / dist
			CCircle(0).CenterChord(1).y = cy2 + h * (CCircle(1).Center.X - CCircle(0).center.X) / dist			

            ' See If we have 1 OR 2 solutions.
            If (dist = CCircle(0).Radius + CCircle(1).Radius) Then Return 1
            Return 2
        End If
    End Sub
Private Sub drawPointCircle(p As PointApi, Clr As Paint)
	cv.DrawLine(p.x, p.y - 10, p.x, p.y + 10, Clr,.5)
	cv.DrawLine(p.x - 10, p.y, p.x + 10, p.y, Clr,.5)	
	cv.drawCircle(p.x , p.y, 10, Clr, False,.5)	
End Sub
Private Sub DrawPoint(p As PointApi )
	cv.DrawLine(p.x, p.y - 5, p.x, p.y + 5, fx.Colors.Blue,.5)
	cv.DrawLine(p.x - 5, p.y, p.x + 5,p.y, fx.Colors.Blue,.5)
End Sub