﻿Type=Class
Version=2.2
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private CTPt() As PointApi 
	Private cv As Canvas 	
	Dim tCircle As Circle3P 
	Dim Radius1 As Double 
	Private msg As String 
	Private msgbox As Msgboxes 
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
 
End Sub
Public Sub Draw_Tangents(c As Canvas, p() As PointApi)
	'Using 	p(0) = center of the circle 
	'		p(1) = radius of the circle
	'		p(2) = external point
	tCircle.Initialize 
	msg=""
	cv = c
	CTPt=p
	Dim ft As Short 
	Dim ln As Short 
	Dim f As Font 
	cv.ClearRect(0,0,cv.Width,cv.Height)	
	tCircle.Center.x = CTPt(0).x 
	tCircle.Center.y = CTPt(0).y
	tCircle.Radius = Functions.Distance(CTPt(0),CTPt(1))
	Functions.draw_Circle(cv, CTPt)
	For i = 0 To 2
		DrawPoint(CTPt(i))
	Next
	ft = FindTangents
	If ft > 0 Then
		f=fx.CreateFont("system", 14,False,False)				
		Dim dPt(2) As PointApi 
		dPt(0).x = CTPt(2).x
		dPt(0).y = CTPt(2).y
		dPt(1).x = tCircle.CenterChord(0).x 
		dPt(1).y = tCircle.CenterChord(0).y 
		drawPointCircle(tCircle.CenterChord(0), fx.Colors.Blue)
		Functions.dashLine(cv, dPt, 1, 5 ,fx.Colors.Green)
		If ft = 2 Then
			dPt(1).x = tCircle.CenterChord(1).x 
			dPt(1).y = tCircle.CenterChord(1).y 
			drawPointCircle(tCircle.CenterChord(1), fx.Colors.Blue)
			Functions.dashLine(cv, dPt, 1, 5 ,fx.Colors.Green) 
		End If
		dPt(1).x = tCircle.Center.x 
		dPt(1).y = tCircle.Center.y 
		Functions.dashdotLine(cv, dPt, 1, 10,fx.Colors.Gray)
		ln = 20: cv.DrawText("X Center Circle = " & tCircle.Center.x , 10, ln, f, fx.Colors.DarkGray , "LEFT")
		ln = ln + 20: cv.DrawText("Y Center Circle = " & tCircle.Center.Y , 10, ln, f, fx.Colors.DarkGray , "LEFT")		
		ln = ln + 20: cv.DrawText("Radius Circle = " & tCircle.radius , 10, ln, f, fx.Colors.DarkGray , "LEFT")	
		ln = ln + 20: cv.DrawText("X Point = " & CTPt(2).x  , 10, ln, f, fx.Colors.DarkGray , "LEFT")
		ln = ln + 20: cv.DrawText("Y Point = " & CTPt(2).Y , 10, ln, f, fx.Colors.DarkGray , "LEFT")
		ln = ln + 20: cv.DrawText("X Tangent Point 1 = " & tCircle.CenterChord(0).x , 10, ln, f, fx.Colors.DarkGray , "LEFT")
		ln = ln + 20: cv.DrawText("Y Tangent Point 1 = " & tCircle.CenterChord(0).y , 10, ln, f, fx.Colors.DarkGray , "LEFT")
		If ft=2 Then
			ln = ln + 20: cv.DrawText("X Tangent Point 2 = " & tCircle.CenterChord(1).x , 10, ln, f, fx.Colors.DarkGray , "LEFT")
			ln = ln + 20: cv.DrawText("Y Tangent Point 2= " & tCircle.CenterChord(1).y , 10, ln, f, fx.Colors.DarkGray , "LEFT")
		Else
			ln =  ln + 20: cv.DrawText(msg, 10, ln, f, fx.Colors.red, "LEFT")
		End If
	Else
		f=fx.CreateFont("system", 14,True,False)		
		ln =  20: cv.DrawText(msg, 10, ln, f, fx.Colors.red, "LEFT")
	End If
	cv.DrawText("To modify click and drag the points.", 10,cv.Height-2,f,fx.Colors.DarkGray, "LEFT")

End Sub
Private Sub FindTangents() As Short
	Dim bl As Int  
    ' Find the distance squared from the
    ' external point to the circle's center.
    Dim dx As Double = tCircle.center.X - CTPt(2).X
   	Dim dy As Double = tCircle.center.Y - CTPt(2).Y
    Dim D_squared As Double = dx * dx + dy * dy

    If (D_squared < tCircle.Radius * tCircle.Radius) Then
        tCircle.CenterChord(0).x = -1
        tCircle.CenterChord(0).y = -1
		tCircle.CenterChord(1).x = -1
		tCircle.CenterChord(1).y = -1
		msg="No solutions, the point is inside the circle"
        Return 0
    End If

    ' Find the distance from the external point
    ' to the tangent points.
    Radius1 = Sqrt(D_squared - tCircle.Radius * tCircle.Radius)

    ' Find the points of intersection between
    ' the original circle and the circle with
    ' center external_point and radius dist.
    
	Dim dist As Double = Sqrt(dx * dx + dy * dy)
   	
	' Find a and h.
    Dim a As Double = (tCircle.Radius * tCircle.Radius - Radius1 * Radius1 + dist * dist) / (2 * dist)
	Dim h As Double = Sqrt(tCircle.Radius * tCircle.Radius - a * a)
   	
	' Find P2.
    Dim cx2 As Double = tCircle.center.X + a * (CTPt(2).X - tCircle.center.X) / dist
    Dim cy2 As Double =  tCircle.center.Y + a * (CTPt(2).Y -  tCircle.center.Y) / dist
	If (dist = tCircle.Radius) Then 
		tCircle.CenterChord(0).x = cx2 + h * (CTPt(2).Y -  tCircle.center.Y) / dist
		tCircle.CenterChord(0).y = cy2 - h * (CTPt(2).X - tCircle.center.X) / dist
		msg="Point is tangent to the circle"
		Return 1
	End If
	' Get the points P3
	tCircle.CenterChord(0).x = cx2 + h * (CTPt(2).Y -  tCircle.center.Y) / dist
	tCircle.CenterChord(0).y = cy2 - h * (CTPt(2).X - tCircle.center.X) / dist
	tCircle.CenterChord(1).x = cx2 - h * (CTPt(2).Y -  tCircle.center.Y) / dist
	tCircle.CenterChord(1).y = cy2 + h * (CTPt(2).X - tCircle.center.X) / dist			

    Return 2	
End Sub
Private Sub drawPointCircle(p As PointApi, Clr As Paint)
	cv.DrawLine(p.x, p.y - 10, p.x, p.y + 10, Clr,.5)
	cv.DrawLine(p.x - 10, p.y, p.x + 10, p.y, Clr,.5)	
	cv.drawCircle(p.x , p.y, 10, Clr, False,.5)	
End Sub
Private Sub DrawPoint(p As PointApi )
	cv.DrawLine(p.x, p.y - 5, p.x, p.y + 5, fx.Colors.Blue,.5)
	cv.DrawLine(p.x - 5, p.y, p.x + 5,p.y, fx.Colors.Blue,.5)
End Sub
