﻿Type=Class
Version=2.2
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private DTHETA As Float 
	Private RADIUS As Float = 100	
	Private x0 As Float
	Private y0 As Float
	Private x As Float
	Private y As Float
	Private theta As Float
	Dim cv As Canvas 
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize

End Sub
Public Sub Text_Circle(c As Canvas, P() As PointApi )
	Dim THE_TEXT As String  = Main.lb.Text 
	Dim cx As Float
	Dim cy As Float
	Dim theta As Float
	Dim DTHETA As Float
	Dim xradius As Float
	Dim yradius As Float
	Dim currentPt As PointApi
	Dim i As Int
	Dim angle As Double
	Dim ElipsePer As Double
	Dim ElipsePart As Double 
	Dim NewPt As PointApi 
	Dim f As Font 
	cv=c
	cv.ClearRect(0,0,c.Width,c.Height)	
	P(1).y = P(0).y
	P(2).x = P(0).x
    cx = P(0).x 
    cy = P(0).y 
	currentPt.X = cx
    currentPt.Y = cy
    DrawPoint(P(0))
	DrawPoint(P(1))
	DrawPoint(P(2))
    theta = cPI
    xradius = Functions.Distance(P(0),P(1))
    yradius = Functions.Distance(P(0),P(2))  'p(2) = p(1) for the circle
	
	'***********  Perimeter of the ellipse  (Srinivāsa Aiyangār Rāmānujan) *******************
	ElipsePer=cPI * (3 * (xradius + yradius) - (Sqrt((3 * xradius + yradius) * (xradius + 3 * yradius))))

	If ElipsePer - Main.lb.Snapshot.Width < Main.lb.Font.Size Then
		f = fx.CreateFont("system", 14,True,False)		
		ln =  20: cv.DrawText("Small perimeter for text.", 10, ln, f, fx.Colors.red, "LEFT")
		Main.lb.Text=THE_TEXT
		Return
	End If
    DTHETA = cPI / (ElipsePer/2)
	ElipsePart = (ElipsePer /2 -  Main.lb.Snapshot.Width) /2
	theta = theta - DTHETA * ElipsePart 
    currentPt.X = cx + xradius * Cos(theta)
    currentPt.Y = cy - yradius * Sin(theta)
	
	f= Main.lb.Font 		
    For i = 0 To Main.lb.Text.Length -1
		Main.lb.Text = THE_TEXT.SubString2(i,i+1)
        theta = theta - DTHETA * Main.lb.Snapshot.Width		
        NewPt.X = cx + xradius * Cos(theta)
        NewPt.Y = cy - yradius * Sin(theta)
		angle = Functions.AngleCalc(currentPt.x, currentPt.y,NewPt.x,NewPt.y)
		c.DrawTextRotated(THE_TEXT.SubString2(i,i+1),currentPt.x, currentPt.y, f, fx.Colors.Magenta,"LEFT", 90-angle)
        currentPt.X =NewPt.x 
        currentPt.Y = NewPt.y 
	Next
	f=fx.CreateFont("system", 14,False,False)		
	'Draw Info
	ln = 20: cv.DrawText("X Center Circle = " & cx , 10, ln, f, fx.Colors.DarkGray , "LEFT")
	ln = ln + 20: cv.DrawText("Y Center Circle = " & cy , 10, ln, f, fx.Colors.DarkGray , "LEFT")	
	ln = ln + 20: cv.DrawText("X Radius = " & xradius, 10, ln, f, fx.Colors.DarkGray , "LEFT")
	ln = ln + 20: cv.DrawText("Y Radius = " & yradius, 10, ln, f, fx.Colors.DarkGray , "LEFT")			
	Main.lb.Text=THE_TEXT	'Restore label text
	cv.DrawText("To modify click and drag the points.", 10,cv.Height-2,f,fx.Colors.DarkGray, "LEFT")
	
End Sub

Private Sub DrawPoint(p As PointApi )
	cv.DrawLine(p.x, p.y - 5, p.x, p.y + 5, fx.Colors.Blue,.5)
	cv.DrawLine(p.x - 5, p.y, p.x + 5,p.y, fx.Colors.Blue,.5)
End Sub